## whisper.cpp 1.7.6+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5) # for add_link_options and implicit target directories.
project("whisper.cpp" C CXX)
project("whisper.cpp" VERSION 1.7.6)
include(CheckIncludeFileCXX)

set(SOVERSION 1)

#set(CMAKE_WARN_DEPRECATED YES)
set(CMAKE_WARN_UNUSED_CLI YES)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

if (NOT XCODE AND NOT MSVC AND NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type" FORCE)
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

# Add path to modules
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    set(WHISPER_STANDALONE ON)

    include(git-vars)

    # configure project version
    configure_file(${CMAKE_SOURCE_DIR}/bindings/javascript/package-tmpl.json ${CMAKE_SOURCE_DIR}/bindings/javascript/package.json @ONLY)
else()
    set(WHISPER_STANDALONE OFF)
endif()

if (EMSCRIPTEN)
    set(BUILD_SHARED_LIBS_DEFAULT OFF)

    option(WHISPER_WASM_SINGLE_FILE "whisper: embed WASM inside the generated whisper.js" ON)

    # TODO: without these, we get the following error:
    #       wasm-ld: error: --shared-memory is disallowed by whisper.cpp.o because it was not compiled with 'atomics' or 'bulk-memory' features.
    set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -pthread")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")

    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -s TOTAL_STACK=5242880")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -s TOTAL_STACK=5242880")

    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated")
else()
    if (MINGW)
        set(BUILD_SHARED_LIBS_DEFAULT OFF)
    else()
        set(BUILD_SHARED_LIBS_DEFAULT ON)
    endif()
endif()

option(BUILD_SHARED_LIBS "build shared libraries" ${BUILD_SHARED_LIBS_DEFAULT})

#
# option list
#

# debug
option(WHISPER_ALL_WARNINGS           "whisper: enable all compiler warnings"                   ON)
option(WHISPER_ALL_WARNINGS_3RD_PARTY "whisper: enable all compiler warnings in 3rd party libs" OFF)

# build
option(WHISPER_FATAL_WARNINGS  "whisper: enable -Werror flag"               OFF)
option(WHISPER_USE_SYSTEM_GGML "whisper: use system-installed GGML library" OFF)

# sanitizers
option(WHISPER_SANITIZE_THREAD    "whisper: enable thread sanitizer"    OFF)
option(WHISPER_SANITIZE_ADDRESS   "whisper: enable address sanitizer"   OFF)
option(WHISPER_SANITIZE_UNDEFINED "whisper: enable undefined sanitizer" OFF)

# extra artifacts
option(WHISPER_BUILD_TESTS    "whisper: build tests"          ${WHISPER_STANDALONE})
option(WHISPER_BUILD_EXAMPLES "whisper: build examples"       ${WHISPER_STANDALONE})
option(WHISPER_BUILD_SERVER   "whisper: build server example" ${WHISPER_STANDALONE})

# 3rd party libs
option(WHISPER_CURL "whisper: use libcurl to download model from an URL" OFF)
option(WHISPER_SDL2 "whisper: support for libSDL2" OFF)

if (CMAKE_SYSTEM_NAME MATCHES "Linux")
    option(WHISPER_FFMPEG "whisper: support building and linking with ffmpeg libs (avcodec, swresample, ...)" OFF)
endif()

option(WHISPER_COREML                "whisper: enable Core ML framework"  OFF)
option(WHISPER_COREML_ALLOW_FALLBACK "whisper: allow non-CoreML fallback" OFF)
option(WHISPER_OPENVINO              "whisper: support for OpenVINO"      OFF)

# Required for relocatable CMake package
include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/build-info.cmake)

# override ggml options
set(GGML_SANITIZE_THREAD    ${WHISPER_SANITIZE_THREAD})
set(GGML_SANITIZE_ADDRESS   ${WHISPER_SANITIZE_ADDRESS})
set(GGML_SANITIZE_UNDEFINED ${WHISPER_SANITIZE_UNDEFINED})
set(GGML_ALL_WARNINGS       ${WHISPER_ALL_WARNINGS})
set(GGML_FATAL_WARNINGS     ${WHISPER_FATAL_WARNINGS})

# transition helpers
function (whisper_option_depr TYPE OLD NEW)
    if (${OLD})
        message(${TYPE} "${OLD} is deprecated and will be removed in the future.\nUse ${NEW} instead\n")
        set(${NEW} ON)
    endif()
endfunction()

whisper_option_depr(FATAL_ERROR WHISPER_CUBLAS              GGML_CUDA)
whisper_option_depr(WARNING     WHISPER_CUDA                GGML_CUDA)
whisper_option_depr(WARNING     WHISPER_KOMPUTE             GGML_KOMPUTE)
whisper_option_depr(WARNING     WHISPER_METAL               GGML_METAL)
whisper_option_depr(WARNING     WHISPER_METAL_EMBED_LIBRARY GGML_METAL_EMBED_LIBRARY)
whisper_option_depr(WARNING     WHISPER_NATIVE              GGML_NATIVE)
whisper_option_depr(WARNING     WHISPER_OPENMP              GGML_OPENMP)
whisper_option_depr(WARNING     WHISPER_RPC                 GGML_RPC)
whisper_option_depr(WARNING     WHISPER_SYCL                GGML_SYCL)
whisper_option_depr(WARNING     WHISPER_SYCL_F16            GGML_SYCL_F16)
whisper_option_depr(WARNING     WHISPER_CCACHE              GGML_CCACHE)

if (GGML_CUDA AND NOT MSVC)
    #GGML_CUDA enabled, add the necessary compile options -Wno-deprecated-gpu-targets
    add_compile_options(-Wno-deprecated-gpu-targets)
endif()

#
# build the library
#

if (NOT TARGET ggml)
    if (WHISPER_USE_SYSTEM_GGML)
        find_package(ggml REQUIRED)
        if (NOT ggml_FOUND)
            message(FATAL_ERROR "System-installed GGML library not found.")
        endif()
        add_library(ggml ALIAS ggml::ggml)
    else()
        add_subdirectory(ggml)
        if(WIN32)
            # The following adds a _DISABLE_CONSTEXPR_MUTEX_CONSTRUCTOR macro and is a workaround for
            # the Windows C++ standard library which does not support constexpr mutexes.
            # From the release notes://github.com/microsoft/STL/wiki/Changelog
            #  Disable constexpr mutex constructor on Windows
            #  Fixed mutex's constructor to be constexpr. #3824 #4000 #4339
            #  Note: Programs that aren't following the documented restrictions on binary compatibility may encounter
            #  null dereferences in mutex machinery. You must follow this rule:
            #  When you mix binaries built by different supported versions of the toolset, the Redistributable version
            #  must be at least as new as the latest toolset used by any app component.
            #  You can define _DISABLE_CONSTEXPR_MUTEX_CONSTRUCTOR as an escape hatch.
            #
            # Specifically to whisper.cpp this would cause a crash when using the Java bindings.
            # resulting in a Invalid memory access error.
            target_compile_definitions(ggml-base PRIVATE _DISABLE_CONSTEXPR_MUTEX_CONSTRUCTOR)
        endif()
    endif()
    # ... otherwise assume ggml is added by a parent CMakeLists.txt
endif()
add_subdirectory(src)

#
# install
#

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

set(WHISPER_BUILD_NUMBER        ${BUILD_NUMBER})
set(WHISPER_BUILD_COMMIT        ${BUILD_COMMIT})
set(WHISPER_INSTALL_VERSION     ${CMAKE_PROJECT_VERSION})

set(WHISPER_INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR} CACHE PATH "Location of header  files")
set(WHISPER_LIB_INSTALL_DIR     ${CMAKE_INSTALL_LIBDIR}     CACHE PATH "Location of library files")
set(WHISPER_BIN_INSTALL_DIR     ${CMAKE_INSTALL_BINDIR}     CACHE PATH "Location of binary  files")

get_directory_property(WHISPER_TRANSIENT_DEFINES COMPILE_DEFINITIONS)

set_target_properties(whisper PROPERTIES PUBLIC_HEADER ${CMAKE_CURRENT_SOURCE_DIR}/include/whisper.h)
install(TARGETS whisper LIBRARY PUBLIC_HEADER)

configure_package_config_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/cmake/whisper-config.cmake.in
        ${CMAKE_CURRENT_BINARY_DIR}/whisper-config.cmake
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/whisper
    PATH_VARS
    WHISPER_INCLUDE_INSTALL_DIR
    WHISPER_LIB_INSTALL_DIR
    WHISPER_BIN_INSTALL_DIR )

write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/whisper-version.cmake
    VERSION ${WHISPER_INSTALL_VERSION}
    COMPATIBILITY SameMajorVersion)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/whisper-config.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/whisper-version.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/whisper)

configure_file(cmake/whisper.pc.in
        "${CMAKE_CURRENT_BINARY_DIR}/whisper.pc"
        @ONLY)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/whisper.pc"
        DESTINATION lib/pkgconfig)

#
# programs, examples and tests
#

if (WHISPER_BUILD_TESTS AND NOT CMAKE_JS_VERSION)
    include(CTest)
    add_subdirectory(tests)
endif ()

if (WHISPER_BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

if (MSVC)
    set(MSVC_WARNING_FLAGS
        /wd4101  # Unreferenced local variable
        /wd4005  # Macro redefinition
        /wd4065  # switch statement contains 'default' but no 'case' labels
        /wd4267  # Conversion from 'size_t' to a smaller type, possible loss of data
        /wd4244  # Conversion from one type to another type, possible loss of ata
        /wd4805  # Unsafe mix of type
        /wd4305  # Truncation from 'type1' to 'type2' (often double to float)
        /wd4996  # Function or variable may be unsafe/deprecated
    )
    function(disable_msvc_warnings target_name)
        if(TARGET ${target_name})
            target_compile_options(${target_name} PRIVATE ${MSVC_WARNING_FLAGS})
        endif()
    endfunction()

    if (WHISPER_BUILD_EXAMPLES)
        disable_msvc_warnings(whisper)
        disable_msvc_warnings(common)
        disable_msvc_warnings(common-sdl)
        disable_msvc_warnings(lsp)
        disable_msvc_warnings(wchess-core)
        disable_msvc_warnings(whisper-command)
        disable_msvc_warnings(whisper-cli)
        disable_msvc_warnings(whisper-server)
        disable_msvc_warnings(whisper-stream)
        disable_msvc_warnings(whisper-talk-llama)
        disable_msvc_warnings(whisper-bench)
        disable_msvc_warnings(quantize)
        disable_msvc_warnings(vad-speech-segments)
    endif()
endif()

=== examples/CMakeLists.txt ===
# dependencies

find_package(Threads REQUIRED)

# third-party

if (WHISPER_SDL2)
    # SDL2
    find_package(SDL2 REQUIRED)

    string(STRIP "${SDL2_LIBRARIES}" SDL2_LIBRARIES)

    message(STATUS "SDL2_INCLUDE_DIRS = ${SDL2_INCLUDE_DIRS}")
    message(STATUS "SDL2_LIBRARIES    = ${SDL2_LIBRARIES}")
endif()

# common

set(TARGET common)

unset(COMMON_EXTRA_LIBS)

if (WHISPER_FFMPEG)
    # As of cmake 3.27, there is no official cmake support for FindFFmpeg.
    # Consequnelty we added a FindFFmpeg.cmake script the cmake subfolder:
    # whisper.cpp does not need the full ffmpeg libs, just AVFORMAT AVCODEC AVUTIL SWRESAMPLE
    # libswresample  performs highly optimized audio resampling, rematrixing and sample format conversion operations
    # libavcodec provides a generic encoding/decoding framework and contains multiple decoders and encoders for audio, video and subtitle streams, and several bitstream filters.
    # libavformat provides a generic framework for multiplexing and demultiplexing (muxing and demuxing) audio, video and subtitle streams.
    find_package(FFmpeg REQUIRED)

    if (NOT ${FFMPEG_FOUND})
        message(FATAL_ERROR "Cannot find ffmpeg libs/headers")
    endif()

    message(STATUS "Found ffmpeg libs:       ${FFMPEG_LIBRARIES}")
    message(STATUS "Found ffmpeg headers in: ${FFMPEG_INCLUDE_DIRS}")
    message(STATUS "ffmpeg definitions:      ${FFMPEG_DEFINITIONS}")
    message(STATUS "Found avformat           ${AVFORMAT_VERSION}")

    include_directories(${FFMPEG_INCLUDE_DIRS})
    add_compile_definitions(WHISPER_FFMPEG)

    list(APPEND COMMON_EXTRA_LIBS ${FFMPEG_LIBRARIES})

    set(COMMON_SOURCES_FFMPEG ffmpeg-transcode.cpp)
endif()


add_library(${TARGET} STATIC
    common.h
    common.cpp
    common-ggml.h
    common-ggml.cpp
    common-whisper.h
    common-whisper.cpp
    grammar-parser.h
    grammar-parser.cpp
    ${COMMON_SOURCES_FFMPEG}
    )

include(DefaultTargetOptions)

target_link_libraries(${TARGET} PRIVATE whisper ${COMMON_EXTRA_LIBS} ${CMAKE_DL_LIBS})

set_target_properties(${TARGET} PROPERTIES POSITION_INDEPENDENT_CODE ON)
set_target_properties(${TARGET} PROPERTIES FOLDER "libs")

if (WHISPER_SDL2)
    # common-sdl

    set(TARGET common-sdl)

    add_library(${TARGET} STATIC
        common-sdl.h
        common-sdl.cpp
        )

    include(DefaultTargetOptions)

    target_include_directories(${TARGET} PUBLIC  ${SDL2_INCLUDE_DIRS})
    target_link_libraries     (${TARGET} PRIVATE ${SDL2_LIBRARIES})

    set_target_properties(${TARGET} PROPERTIES POSITION_INDEPENDENT_CODE ON)
    set_target_properties(${TARGET} PROPERTIES FOLDER "libs")
endif()

# add json lib
add_library(json_cpp INTERFACE)
target_include_directories(json_cpp INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})

# examples

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

if (EMSCRIPTEN)
    add_subdirectory(whisper.wasm)
    add_subdirectory(stream.wasm)
    add_subdirectory(command.wasm)
    add_subdirectory(bench.wasm)
elseif(CMAKE_JS_VERSION)
    add_subdirectory(addon.node)
else()
    add_subdirectory(cli)
    add_subdirectory(bench)
    add_subdirectory(server)
    add_subdirectory(quantize)
    add_subdirectory(vad-speech-segments)
    if (WHISPER_SDL2)
        add_subdirectory(stream)
        add_subdirectory(command)
        add_subdirectory(talk-llama)
        add_subdirectory(lsp)
        if (GGML_SYCL)
            add_subdirectory(sycl)
        endif()
    endif (WHISPER_SDL2)

    add_subdirectory(deprecation-warning)
endif()

if (WHISPER_SDL2)
    add_subdirectory(wchess)
endif (WHISPER_SDL2)

=== tests/CMakeLists.txt ===
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if (EMSCRIPTEN)
    #
    # test-whisper-js

    set(TEST_TARGET test-whisper-js)

    add_test(NAME ${TEST_TARGET}
        COMMAND node test-whisper.js --experimental-wasm-threads
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )

    return()
endif()

set(TEST_TARGET test-whisper-cli-tiny)
add_test(NAME ${TEST_TARGET}
    COMMAND $<TARGET_FILE:whisper-cli>
    -m ${PROJECT_SOURCE_DIR}/models/for-tests-ggml-tiny.bin -l fr
    -f ${PROJECT_SOURCE_DIR}/samples/jfk.wav)
set_tests_properties(${TEST_TARGET} PROPERTIES LABELS "tiny;gh")

set(TEST_TARGET test-whisper-cli-tiny.en)
add_test(NAME ${TEST_TARGET}
    COMMAND $<TARGET_FILE:whisper-cli>
    -m ${PROJECT_SOURCE_DIR}/models/for-tests-ggml-tiny.en.bin
    -f ${PROJECT_SOURCE_DIR}/samples/jfk.wav)
set_tests_properties(${TEST_TARGET} PROPERTIES LABELS "tiny;en")

set(TEST_TARGET test-whisper-cli-base)
add_test(NAME ${TEST_TARGET}
    COMMAND $<TARGET_FILE:whisper-cli>
    -m ${PROJECT_SOURCE_DIR}/models/for-tests-ggml-base.bin -l fr
    -f ${PROJECT_SOURCE_DIR}/samples/jfk.wav)
set_tests_properties(${TEST_TARGET} PROPERTIES LABELS "base")

set(TEST_TARGET test-whisper-cli-base.en)
add_test(NAME ${TEST_TARGET}
    COMMAND $<TARGET_FILE:whisper-cli>
    -m ${PROJECT_SOURCE_DIR}/models/for-tests-ggml-base.en.bin
    -f ${PROJECT_SOURCE_DIR}/samples/jfk.wav)
set_tests_properties(${TEST_TARGET} PROPERTIES LABELS "base;en")

set(TEST_TARGET test-whisper-cli-small)
add_test(NAME ${TEST_TARGET}
    COMMAND $<TARGET_FILE:whisper-cli>
    -m ${PROJECT_SOURCE_DIR}/models/for-tests-ggml-small.bin -l fr
    -f ${PROJECT_SOURCE_DIR}/samples/jfk.wav)
set_tests_properties(${TEST_TARGET} PROPERTIES LABELS "small")

set(TEST_TARGET test-whisper-cli-small.en)
add_test(NAME ${TEST_TARGET}
    COMMAND $<TARGET_FILE:whisper-cli>
    -m ${PROJECT_SOURCE_DIR}/models/for-tests-ggml-small.en.bin
    -f ${PROJECT_SOURCE_DIR}/samples/jfk.wav)
set_tests_properties(${TEST_TARGET} PROPERTIES LABELS "small;en")

set(TEST_TARGET test-whisper-cli-medium)
add_test(NAME ${TEST_TARGET}
    COMMAND $<TARGET_FILE:whisper-cli>
    -m ${PROJECT_SOURCE_DIR}/models/for-tests-ggml-medium.bin -l fr
    -f ${PROJECT_SOURCE_DIR}/samples/jfk.wav)
set_tests_properties(${TEST_TARGET} PROPERTIES LABELS "medium")

set(TEST_TARGET test-whisper-cli-medium.en)
add_test(NAME ${TEST_TARGET}
    COMMAND $<TARGET_FILE:whisper-cli>
    -m ${PROJECT_SOURCE_DIR}/models/for-tests-ggml-medium.en.bin
    -f ${PROJECT_SOURCE_DIR}/samples/jfk.wav)
set_tests_properties(${TEST_TARGET} PROPERTIES LABELS "medium;en")

set(TEST_TARGET test-whisper-cli-large)
add_test(NAME ${TEST_TARGET}
    COMMAND $<TARGET_FILE:whisper-cli>
    -m ${PROJECT_SOURCE_DIR}/models/for-tests-ggml-large.bin
    -f ${PROJECT_SOURCE_DIR}/samples/jfk.wav)
set_tests_properties(${TEST_TARGET} PROPERTIES LABELS "large")

if (WHISPER_FFMPEG)
    set(TEST_TARGET test-whisper-cli-tiny-mp3)
    # Check with reviewers: any way to check the output transcription via ctest (diff, ...)?
    add_test(NAME ${TEST_TARGET}
      COMMAND $<TARGET_FILE:whisper-cli>
      -m ${PROJECT_SOURCE_DIR}/models/for-tests-ggml-tiny.en.bin
      -f ${PROJECT_SOURCE_DIR}/samples/jfk.mp3)
    set_tests_properties(${TEST_TARGET} PROPERTIES LABELS "tiny;mp3")
endif()

# VAD test tests VAD in isolation
set(VAD_TEST test-vad)
add_executable(${VAD_TEST} ${VAD_TEST}.cpp)
target_include_directories(${VAD_TEST} PRIVATE ../include ../ggml/include ../examples)
target_link_libraries(${VAD_TEST} PRIVATE common)
add_test(NAME ${VAD_TEST} COMMAND ${VAD_TEST})
set_tests_properties(${VAD_TEST} PROPERTIES LABELS "unit")

# VAD test full uses whisper_full with VAD enabled
set(VAD_TEST test-vad-full)
add_executable(${VAD_TEST} ${VAD_TEST}.cpp)
target_include_directories(${VAD_TEST} PRIVATE ../include ../ggml/include ../examples)
target_link_libraries(${VAD_TEST} PRIVATE common)
add_test(NAME ${VAD_TEST} COMMAND ${VAD_TEST})
set_tests_properties(${VAD_TARGET} PROPERTIES LABELS "base;en")

=== examples/talk-llama/CMakeLists.txt ===
if (WHISPER_SDL2)
    set(CMAKE_CXX_STANDARD 17)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)

    set(TARGET whisper-talk-llama)
    add_executable(${TARGET} talk-llama.cpp
        llama.cpp
        llama-adapter.cpp
        llama-arch.cpp
        llama-batch.cpp
        llama-chat.cpp
        llama-context.cpp
        llama-cparams.cpp
        llama-grammar.cpp
        llama-graph.cpp
        llama-hparams.cpp
        llama-impl.cpp
        llama-io.cpp
        llama-kv-cache-unified.cpp
        llama-kv-cache-unified-iswa.cpp
        llama-memory-recurrent.cpp
        llama-memory-hybrid.cpp
        llama-memory.cpp
        llama-mmap.cpp
        llama-model-loader.cpp
        llama-model-saver.cpp
        llama-model.cpp
        llama-quant.cpp
        llama-sampling.cpp
        llama-vocab.cpp
        unicode.cpp
        unicode-data.cpp)
    target_include_directories(${TARGET} PRIVATE ${SDL2_INCLUDE_DIRS})

    target_link_libraries(${TARGET} PRIVATE common common-sdl whisper ${SDL2_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})

    if(WIN32)
        # It requires Windows 8.1 or later for PrefetchVirtualMemory
        target_compile_definitions(${TARGET} PRIVATE -D_WIN32_WINNT=0x0602)
    endif()

    include(DefaultTargetOptions)
endif ()

=== debian/changelog ===
whisper.cpp (1.7.6+dfsg-1) experimental; urgency=medium

  * Team upload.

  * New upstream version 1.7.6+dfsg
    - Introduce DFSG-cleaning for upstream source
  * Refresh / drop obsolete patches
  * Add 2030-workarounds-for-DFSG-cleaning.patch
  * d/rules: Use system ggml
  * Add dependency on libggml
  * Update d/copyright
  * De-duplicate short descriptions
  * Bump Standards-Version to 4.7.2 (no changes needed)
  * Drop dependency on libclblast-dev
  * Update upstream URLs
  * Install AUTHORS file
  * Disable tests ending license question of samples

 -- Christian Kastner <ckk@debian.org>  Sat, 21 Jun 2025 11:16:51 +0200

whisper.cpp (1.7.4-2) unstable; urgency=medium

  * Extended debian/copyright a bit based on feedback from lrc.
  * Adjust d/copyright, fix a typo and make it more specific.

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 18 Apr 2025 23:30:49 +0200

whisper.cpp (1.7.4-1) unstable; urgency=medium

  * Initial release (Closes: #1064101).

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 08 Mar 2025 12:28:21 +0100

=== debian/control ===
Source: whisper.cpp
Section: libs
Priority: optional
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Petter Reinholdtsen <pere@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libsdl2-dev,
               libggml-cpu (= 0.0~git20250618.9e4bee1-1),
Standards-Version: 4.7.2
Homepage: https://github.com/ggml-org/whisper.cpp/
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/deeplearning-team/whisper.cpp.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/whisper.cpp

Package: whisper.cpp
Architecture: any
Multi-Arch: foreign
Depends: libggml-cpu (= 0.0~git20250618.9e4bee1-1) |
                libggml-backend (= 0.0~git20250618.9e4bee1-1),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Automatic speech recogniztion and transcibing
 Port of OpenAI's Whisper automatic speech recogniztion model in C/C++ as
 a shared library, with both CPU and GPU support.

Package: libwhisper-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libwhisper1 (= ${binary:Version})
Description: Automatic speech recogniztion and transcibing - development files
 Port of OpenAI's Whisper automatic speech recogniztion model in C/C++ as
 a shared library, with both CPU and GPU support.
 .
 Headers and development files.

Package: libwhisper1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Automatic speech recogniztion and transcibing - library
 Port of OpenAI's Whisper automatic speech recogniztion model in C/C++ as
 a shared library, with both CPU and GPU support.
 .
 Shared library.

## whisper.cpp 1.8.0

=== debian/changelog ===
whisper.cpp (1.8.0-1) unstable; urgency=medium

  * Align package names with Debian official

 -- Mathieu Baudier <mbaudier@argeo.org>  Sat, 18 Oct 2025 10:47:56 +0000
 

=== debian/control ===
Source: whisper.cpp
Section: science
Priority: optional
Maintainer: Mathieu Baudier <mbaudier@argeo.org>
Standards-Version: 4.7.2
Vcs-Browser: https://git.djapps.eu/?p=pkg/ggml/sources/whisper.cpp;a=summary
Vcs-Git: https://git.djapps.eu/pkg/ggml/sources/whisper.cpp
Homepage: https://github.com/ggml-org/whisper.cpp
Build-Depends: cmake,
               debhelper-compat (= 13),
               libsdl2-dev,
               libggml-dev,
               libllama-dev,
               pkgconf,
Rules-Requires-Root: no

Package: libwhisper1
Section: libs
Architecture: any
Multi-Arch: same
Depends: libggml0
         ${misc:Depends},
         ${shlibs:Depends}
Description: Inference of Whisper in pure C/C++ (shared library)
 The shared library provides the core of whisper.cpp
 speech-to-text capabilities using a Whisper model.

Package: whisper.cpp-cli
Architecture: any
Multi-Arch: same
Depends: libwhisper1,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Inference of Whisper in pure C/C++ (CLI)
 A versatile tool giving command line access to most
 whisper-cpp capabilities.

Package: whisper.cpp-stream
Architecture: any
Multi-Arch: same
Depends: libwhisper1,
         libsdl2-2.0-0,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Inference of Whisper in pure C/C++ (stream)
 Real-time speech-to-text of SDL sound input.
 The SDL sound input (typically a microphone) is
 transcribed as text to the standard output.

Package: whisper.cpp-talk-llama
Architecture: any
Multi-Arch: same
Depends: libwhisper1,
         libllama0,
         espeak-ng,
         libswresample4,
         libavcodec59,
         libavformat59,
         libsdl2-2.0-0,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Inference of Whisper in pure C/C++ (talk-llama)
 A tool allowing one to "talk" with a large language model,
 using llama.cpp.
 The SDL input (typically from a microphone) is translated
 into text by whisper.cpp and sent to llama.cpp for processing.

Package: libwhisper-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libwhisper1 (= ${binary:Version}),
         libggml-dev,
         ${misc:Depends}
Description: Inference of Whisper in pure C/C++ (development files)
 Development files for using whisper.cpp as a shared library
 in applications.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
#export DH_VERBOSE = 1

# multiarch
include /usr/share/dpkg/architecture.mk

build_multiarch=build/$(DEB_HOST_MULTIARCH)
install_bin=debian/tmp/usr/bin
install_lib=debian/tmp/usr/lib
install_lib_multiarch=debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
install_libexec_multiarch=debian/tmp/usr/libexec/$(DEB_HOST_MULTIARCH)

# parallelism
DEB_BUILD_OPTIONS ?= parallel=8

# hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
# Use build/ for output, so that it is in the .gitignore of upstream
	dh $@ --buildsystem=cmake --builddirectory=$(build_multiarch)

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)" \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	\
	-DBUILD_SHARED_LIBS=ON \
	-DWHISPER_USE_SYSTEM_GGML=ON \
	-DCMAKE_LIBRARY_PATH=/usr/libexec/$(DEB_HOST_MULTIARCH)/ggml \
	\
	-DWHISPER_BUILD_TESTS=OFF \
	-DWHISPER_BUILD_EXAMPLES=ON \
	-DWHISPER_FFMPEG=OFF \
	-DWHISPER_SDL2=ON \

override_dh_auto_install:
	dh_auto_install
	
	# Move executables to libexec, so that they can load the GGML backends
	# and link them to bin
	mkdir -p $(install_libexec_multiarch)/ggml
	for file in $(install_bin)/whisper-*; do \
    	mv $$file $(install_libexec_multiarch)/ggml/$$(basename "$$file"); \
		ln -s --relative -t $(install_bin) $(install_libexec_multiarch)/ggml/$$(basename "$$file"); \
	done
	
	# Multiarch pkgconfig
	mkdir -p $(install_lib_multiarch)/pkgconfig
	mv $(install_lib)/pkgconfig/*.pc $(install_lib_multiarch)/pkgconfig

override_dh_auto_test:
	# tests which depends on remote location are failing
	dh_auto_test || true

## whisper.cpp 1.8.2

=== debian/changelog ===
whisper.cpp (1.8.2-1) unstable; urgency=medium

  * Update upstream

 -- Mathieu Baudier <mbaudier@argeo.org>  Tue, 11 Nov 2025 09:31:12 +0000

## whisper.cpp 1.8.2+dfsg

=== debian/changelog ===
whisper.cpp (1.8.2+dfsg-4) unstable; urgency=medium

  * Bump Standards-Version to 4.7.3
    - Drop Priority: optional, it's the dpkg default since trixie
  * Tag patch as Forwarded: not-needed
  * Install pkgconfig to multi-arch destination
  * Enable Salsa CI
  * Bump copyrights
  * Enable symbol tracking
  * libwhisper-dev does not need ${misc:Depends}

 -- Christian Kastner <ckk@debian.org>  Sun, 11 Jan 2026 16:47:30 +0100

whisper.cpp (1.8.2+dfsg-3) unstable; urgency=medium

  [ Mathieu Baudier ]
  * Work around missing macro after ggml v0.9.5 upgrade
  * Adapt to ggml now being a public library
  * Build debug info
  * Use debian/unstable branch instead of master

  [ Christian Kastner ]
  * Bump libggml-dev dependency to 0.9.5.

 -- Mathieu Baudier <mbaudier@argeo.org>  Sat, 03 Jan 2026 16:30:16 +0000

whisper.cpp (1.8.2+dfsg-2) experimental; urgency=medium

  * Refresh d/copyright
  * Generalize lintian overrides

 -- Christian Kastner <ckk@debian.org>  Wed, 31 Dec 2025 11:40:54 +0100

whisper.cpp (1.8.2+dfsg-1) experimental; urgency=medium

  * New upstream version 1.8.2+dfsg
  * Adapt dependencies to changes in ggml Debian packaging
  * Disable talk-llama in order to have a more robust dependency to ggml APIs

 -- Mathieu Baudier <mbaudier@argeo.org>  Tue, 23 Dec 2025 12:29:18 +0000

=== debian/control ===
Source: whisper.cpp
Section: libs
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Petter Reinholdtsen <pere@debian.org>,
           Christian Kastner <ckk@debian.org>,
Build-Depends: cmake,
               debhelper-compat (= 13),
               libsdl2-dev,
               libggml-dev (>= 0.9.5),
Standards-Version: 4.7.3
Homepage: https://github.com/ggml-org/whisper.cpp/
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/deeplearning-team/whisper.cpp.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/whisper.cpp

Package: whisper.cpp
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Automatic speech recognition and transcribing
 Port of OpenAI's Whisper automatic speech recognition model in C/C++ as
 a shared library, with both CPU and GPU support.

Package: libwhisper-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libggml-dev,
         libwhisper1 (= ${binary:Version})
Description: Automatic speech recognition and transcribing - development files
 Port of OpenAI's Whisper automatic speech recognition model in C/C++ as
 a shared library, with both CPU and GPU support.
 .
 Headers and development files.

Package: libwhisper1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Automatic speech recogniztion and transcibing - library
 Port of OpenAI's Whisper automatic speech recognition model in C/C++ as
 a shared library, with both CPU and GPU support.
 .
 Shared library.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%$1.tar.gz%,dversionmangle=auto,repacksuffix=+dfsg" \
   https://github.com/ggml-org/whisper.cpp/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## whisper.cpp 1.8.3%2Bdfsg

=== examples/vad-speech-segments/CMakeLists.txt ===
set(TARGET whisper-vad-speech-segments)
add_executable(${TARGET} speech.cpp)

include(DefaultTargetOptions)

target_link_libraries(${TARGET} PRIVATE common whisper ${FFMPEG_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})

install(TARGETS ${TARGET} RUNTIME)

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
                debhelper-compat (= 13),
                libsdl2-dev,
                libggml-dev (>= 0.9.5),
+               ffmpeg,
 Standards-Version: 4.7.3
 Homepage: https://github.com/ggml-org/whisper.cpp/
 Rules-Requires-Root: no
